#include <string.h>
#include "WFNUMType.h"
#include "cppdemo.h"

void  WFCallingConvention GetParameterStruct(PParameterStruct D)
{
  D->NuE=3;
  D->NuI=0;
  D->NuB=1;
  strncpy(D->NaE[0],"Verstrkung k1 fr Steuereing. < 0",39);
  strncpy(D->NaE[1],"Verstrkung k2 fr Steuereing. = 0",39);
  strncpy(D->NaE[2],"Verstrkung k3 fr Steuereing. > 0",39);
  strncpy(D->NaB[0],"Ausgang invertiert",39);
  D->E[0]=double2NUMType(1);
  D->E[1]=double2NUMType(5);
  D->E[2]=double2NUMType(10);
  D->B[0]=0;
  D->EMin[0]=double2NUMType(0.0); D->EMax[0]=double2NUMType(100000);
  D->EMin[1]=double2NUMType(0.0); D->EMax[1]=double2NUMType(100000);
  D->EMin[2]=double2NUMType(0.0); D->EMax[2]=double2NUMType(100000);
}


void WFCallingConvention GetDialogEnableStruct(PDialogEnableStruct D,PParameterStruct D2)
{
//Alle Dialogelemente bis auf Dateien sollen jederzeit zugnglich sein
  D->AllowE=0xFFFFFFFF;
  D->AllowI=0xFFFFFFFF;
  D->AllowB=0xFFFFFFFF;
}


void  WFCallingConvention GetNumberOfInputsOutputs(PNumberOfInputsOutputs D)
{ D->Inputs=2;
  D->Outputs=1;
  strncpy(D->NameI[0],"Steuereingang",39);
  strncpy(D->NameI[1],"Dateneingang",39);
  strncpy(D->NameO[0],"Ausgang",39);
}


int  WFCallingConvention CanSimulateDLL(PParameterStruct D)
{ //Simulation immer zulssig!
  return 1;
}

void WFCallingConvention SimulateDLL(NUMType T,PParameterStruct D,TInputArray Inputs,TOutputArray Outputs)
{
  double I0=NUMType2double(Inputs[0]);
  if (I0<0) //Eingang 1 negativ
    Outputs[0] = double2NUMType(NUMType2double(D->E[0]) * NUMType2double(Inputs[1]));
  else if (I0 == 0) //Eingang 1 null
    Outputs[0] = double2NUMType(NUMType2double(D->E[1]) * NUMType2double(Inputs[1]));
  else //Eingang 1 positiv
    Outputs[0] = double2NUMType(NUMType2double(D->E[2]) * NUMType2double(Inputs[1]));
  if (D->B[0] == 1) //Schalter-Parameter 0 = 1, also Ausgang invertieren
    Outputs[0] = double2NUMType(-NUMType2double(Outputs[0]));
}


void WFCallingConvention InitSimulationDLL(PParameterStruct D,TInputArray Inputs,TOutputArray Outputs)
{/*Der Initialisierungsschritt soll genauso durchgefhrt werden wie alle
   Simulationsschritte. Also rufen wir einfach SimulateDLL auf!*/
 SimulateDLL(double2NUMType(0), D, Inputs, Outputs);
}

void WFCallingConvention EndSimulationDLL(void)
{//wird nicht bentigt
}

char* WFCallingConvention SetInputChar(void)
{
  return "SD";
}

void WFCallingConvention IsUserDLL32(void)
{
}
