
#ifndef WFNumType
#define WFNumType WFNumType

// Diese Headerdatei bietet ein Workaround fr VC++ an.
// In VC++ ist der Typ 'long double' auf 'double' umgemnzt was nach ANSI-C nicht verkehrt ist,
// aber schade, denn der Fliekommaprozessor arbeitet intern mit der maximalen Genauigkeit,
// was z.Zt. 80 Bit also 10 Byte und nicht 8 Byte also 64 Bit sind.

// BORIS verwendet aber 10 Byte groe Fliepunktzahlen was bei VC++ zu einem Problem fhrt.

// Lsung:
//   1.) Verwenden Sie  BERALL  wo laut normalerweise 'long double' stehen 
//       msste den hier deklarierten Typ 'NUMType' !
//   2.) Zur Umrechnung von 'NUMType' zu 'double' und umgekehrt,
//       stehen Ihnen entsprechend benannte (sehr schnelle) Funktionen zur Verfgung.

// Beispiel:
//
//  long double f(long double a) 
//  {
//      a+=1;
//      return a;
//  } 
//
// wird zu:
//
//  NUMType f(NUMType a) 
//  {
//      double d=NUMType2double(a);
//      d+=1;
//      return double2NUMType(d);
//  } 
//
//  Natrlich liee sich dies krzer fassen, aber hier soll die Methode im Vordergrund 
//  stehen!


// Diese Headerdatei setzt alles auf den normalen Zustand 
// (Also NUMType auf long double und die Umrechnungsfunktionen 
//  auf das direkte Argument) falls es sich nicht um VC++ handelt. Somit kann sie
// fr Compiler mit und ohne diesen Unterschied verwendet werden.


#ifndef  _MSC_VER

#define NUMType long double
#define NUMType2double(a) a
#define double2NUMType(a) a

#else
#define MS_LONG_DOUBLE_PROBLEM


typedef struct{ 
	char d[10];
}NUMType;



inline double NUMType2double(const NUMType mem)
{
	double d;
	_asm fld TBYTE PTR mem
	_asm fstp QWORD PTR d
	return d;
}

inline NUMType double2NUMType(const double d)
{
	NUMType mem;
	_asm fld QWORD PTR d
	_asm fstp TBYTE PTR mem
	return mem;
}


#endif

#endif